/* Create a WiFi access point and provide a web server on it to receive command to control motor. */

#include <ESP8266WiFi.h>
#include <WiFiClient.h> 
#include <ESP8266WebServer.h>

/* Set these to your desired credentials. */
const char *ssid = "My_Robot";
const char *password = "iamnotarobot";

ESP8266WebServer server(80);

/* Just a little test message.  Go to http://192.168.4.1 in a web browser
 * connected to this access point to see it.
 */
void handleRoot() {
  server.send(200, "text/plain", "hello from Robot!");
}

void motor_forward(){
    digitalWrite(16, 1);
    digitalWrite(5, 0);
    digitalWrite(4, 1);
    digitalWrite(0, 0);
  }
void motor_stop(){
    digitalWrite(16, 0);
    digitalWrite(5, 0);
    digitalWrite(4, 0);
    digitalWrite(0, 0);
  }
void motor_back(){
    digitalWrite(16, 0);
    digitalWrite(5, 1);
    digitalWrite(4, 0);
    digitalWrite(0, 1);
  }

void motor_left(){
    digitalWrite(16, 0);
    digitalWrite(5, 1);
    digitalWrite(4, 1);
    digitalWrite(0, 0);
  }
void motor_right(){
    digitalWrite(16, 1);
    digitalWrite(5, 0);
    digitalWrite(4, 0);
    digitalWrite(0, 1);
  }


void setup() {
  // prepare Motor Output Pins
  pinMode(16, OUTPUT);
  digitalWrite(16, 0);
  
  // prepare GPIO5 relay 1
  pinMode(5, OUTPUT);
  digitalWrite(5, 0);
  
  pinMode(4, OUTPUT);
  digitalWrite(4, 0);
  
  pinMode(0, OUTPUT);
  digitalWrite(0, 0);

  
	delay(1000);
	Serial.begin(115200);
	Serial.println();
	Serial.print("Configuring access point...");
	/* You can remove the password parameter if you want the AP to be open. */
	WiFi.softAP(ssid, password);

	IPAddress myIP = WiFi.softAPIP();
	Serial.print("AP IP address: ");
	Serial.println(myIP);

 
	server.on("/", handleRoot);
 
  server.on("/inline", []() {
    server.send(200, "text/plain", "this works as well");
  });

  server.on("/fw", []() {
    motor_forward();
    server.send(200, "text/plain", "Forward");
  });
  server.on("/bk", []() {
    motor_back();
    server.send(200, "text/plain", "Back");
  });

  server.on("/st", []() {
    motor_stop();
    server.send(200, "text/plain", "Stop");
  });
  server.on("/lt", []() {
    motor_left();
    server.send(200, "text/plain", "Left");
  });
  server.on("/rt", []() {
    motor_right();
    server.send(200, "text/plain", "Right");
  });

	server.begin();
	Serial.println("HTTP server started");


  
}

void loop() {
	server.handleClient();
}
